﻿using Oxide.Core.Libraries.Covalence;
using Oxide.Core.Plugins;
using System;

namespace Oxide.Plugins {
    [Info("ClanTagsBC", "Mroczny", "1.0.0")]
    [Description("HWClans clan tag integration for BetterChat")]
    public class ClanTagsBC : CovalencePlugin {

        [PluginReference]
        private readonly Plugin BetterChat, HWClans;

        protected override void LoadDefaultConfig() {
            Config["Format"] = "{ClanTag}";
        }

        private void OnServerInitialized() {
            if (BetterChat == null) {
                PrintWarning("BetterChat is not loaded, get it at https://umod.org/plugins/better-chat");
            } else if (HWClans == null) {
                PrintWarning("HWClans is not loaded, get it at xxx");
            }
        }

        private void OnPluginLoaded(Plugin plugin) {
            if (plugin.Name != "BetterChat") {
                BetterChat.CallHook("API_RegisterThirdPartyTitle", this, new Func<IPlayer, string>(GetClanTag));
            }
        }

        private string GetClanTag(IPlayer player) {
            if (HWClans != null) {
                if (HWClans.Call("getClanTag", player.Object) != null) {
                    return Config["Format"].ToString().ReplaceCaseInsensitive("{ClanTag}", HWClans.CallHook("getClanTag", player.Object).ToString());
                }
            }
            return string.Empty;
        }
    }
}